/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Metodos_Ordenacion;

import java.util.Calendar;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;

/**
 *
 * @author Pc
 */
public class Ventana_Metodo_Burbuja extends javax.swing.JFrame {

    /**
     * Creates new form Ventana_Metodo_Burbuja
     */
    public Ventana_Metodo_Burbuja() {
        initComponents();

        setLocationRelativeTo(null);

        setIconImage(new ImageIcon(getClass().getResource("/fotos/icono.jpg")).getImage());//PONER UN ICONO
        ((JPanel) getContentPane()).setOpaque(false);
        ImageIcon uno = new ImageIcon(this.getClass().getResource("/fotos/ci.jpeg"));
        JLabel fondo = new JLabel();
        fondo.setIcon(uno);
        getLayeredPane().add(fondo, JLayeredPane.FRAME_CONTENT_LAYER);
        fondo.setBounds(0, 0, uno.getIconWidth(), uno.getIconHeight());

        setVisible(true);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblTitulo = new javax.swing.JLabel();
        lblElemento = new javax.swing.JLabel();
        lblDatosVector = new javax.swing.JLabel();
        txtElemento = new javax.swing.JTextField();
        txtDatosVector = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstProceso = new javax.swing.JList();
        lblProceso = new javax.swing.JLabel();
        lblDatosOrdenados = new javax.swing.JLabel();
        txtDatosOrdenados = new javax.swing.JTextField();
        btnSalir = new javax.swing.JButton();
        btnNuevo = new javax.swing.JButton();
        lblProceso1 = new javax.swing.JLabel();
        txtssegundos = new javax.swing.JTextField();
        lblProceso2 = new javax.swing.JLabel();
        txttiempo1 = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        txtPasadas = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        btnAgregar = new javax.swing.JButton();
        btnOrdenar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Metodo Burbuja.");

        lblTitulo.setFont(new java.awt.Font("Tahoma", 1, 24)); // NOI18N
        lblTitulo.setText("METODO DE BURBUJA");

        lblElemento.setText("INGRESE EL ELEMENTO");

        lblDatosVector.setText("DATOS DEL VECTOR");

        txtElemento.setColumns(5);
        txtElemento.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtElementoActionPerformed(evt);
            }
        });

        txtDatosVector.setColumns(30);
        txtDatosVector.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtDatosVectorActionPerformed(evt);
            }
        });

        jScrollPane1.setViewportView(lstProceso);

        lblProceso.setText("Tiempo ( en segundos) ");

        lblDatosOrdenados.setText("Datos Ordenados:");

        txtDatosOrdenados.setColumns(30);

        btnSalir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Unavailable_24px.png"))); // NOI18N
        btnSalir.setText("SALIR");
        btnSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSalirActionPerformed(evt);
            }
        });

        btnNuevo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Wipes_24px.png"))); // NOI18N
        btnNuevo.setText("NUEVO");
        btnNuevo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNuevoActionPerformed(evt);
            }
        });

        lblProceso1.setText("PROCESO");

        txtssegundos.setColumns(5);
        txtssegundos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtssegundosActionPerformed(evt);
            }
        });

        lblProceso2.setText("Tiempo ( en nanosegundos) ");

        txttiempo1.setColumns(5);
        txttiempo1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txttiempo1ActionPerformed(evt);
            }
        });

        jLabel1.setText("Numero de Pasadas:");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Opciones."));

        btnAgregar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Cancel_Last_Digit_24px.png"))); // NOI18N
        btnAgregar.setText("AGREGAR");
        btnAgregar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAgregarActionPerformed(evt);
            }
        });

        btnOrdenar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Bill_24px.png"))); // NOI18N
        btnOrdenar.setText("ORDENAR");
        btnOrdenar.setActionCommand("");
        btnOrdenar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOrdenarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(btnOrdenar)
                    .addComponent(btnAgregar))
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(btnAgregar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 8, Short.MAX_VALUE)
                .addComponent(btnOrdenar)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(28, 28, 28)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblDatosOrdenados)
                            .addComponent(lblDatosVector)
                            .addComponent(lblElemento)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(41, 41, 41)
                        .addComponent(lblProceso1)))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addComponent(txtDatosOrdenados, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(btnNuevo)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnSalir)
                                .addGap(22, 22, 22))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 258, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 98, Short.MAX_VALUE)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(txttiempo1, javax.swing.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE)
                                    .addComponent(lblProceso)
                                    .addComponent(lblProceso2)
                                    .addComponent(txtssegundos, javax.swing.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE)
                                    .addComponent(jLabel1)
                                    .addComponent(txtPasadas))
                                .addGap(46, 46, 46))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(80, 80, 80)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(txtDatosVector, javax.swing.GroupLayout.PREFERRED_SIZE, 184, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(74, 74, 74))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(txtElemento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(lblTitulo))
                                .addGap(0, 0, Short.MAX_VALUE))))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addComponent(lblTitulo)
                .addGap(22, 22, 22)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(txtElemento, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblElemento))
                        .addGap(32, 32, 32)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblDatosVector)
                            .addComponent(txtDatosVector, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(23, 23, 23))
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(31, 31, 31)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(lblProceso2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(txttiempo1, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(lblProceso)
                                .addGap(18, 18, 18)
                                .addComponent(txtssegundos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(33, 33, 33)
                                .addComponent(jLabel1)))
                        .addGap(18, 18, 18)
                        .addComponent(txtPasadas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 17, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblDatosOrdenados)
                            .addComponent(txtDatosOrdenados, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(btnSalir)
                            .addComponent(btnNuevo))
                        .addGap(20, 20, 20))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(lblProceso1)
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    Vector datos = new Vector();
    private void btnAgregarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAgregarActionPerformed

        Integer elementos = Integer.parseInt(txtElemento.getText());
        datos.add(elementos);
        txtDatosVector.setText(" " + datos);
        txtElemento.selectAll(); // para que quede seleccionado**
        txtElemento.requestFocus();//// para ponr el cursor en el componente
    }//GEN-LAST:event_btnAgregarActionPerformed

    private void txtElementoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtElementoActionPerformed
        btnAgregarActionPerformed(evt);
        txtElemento.selectAll();
        txtElemento.requestFocus();
    }//GEN-LAST:event_txtElementoActionPerformed
    Vector Proceso = new Vector();
    private void btnOrdenarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOrdenarActionPerformed
        long inc = System.nanoTime();

        Vector<Integer> ordenarElementos = new Vector();
        ordenarElementos.addAll(datos);

        for (int i = 0; i < datos.size() - 1; i++) {
            Proceso.add("Pasada " + (i + 1));
            Proceso.add("____________________________");
            for (int j = 0; j < datos.size() - i - 1; j++) {
                Vector vProceso = new Vector();
                if (ordenarElementos.get(j) > ordenarElementos.get(j + 1)) {
                    Integer aux = ordenarElementos.get(j);
                    ordenarElementos.set(j, ordenarElementos.get(j + 1));
                    ordenarElementos.set(j + 1, aux);
                }
                for (int k = 0; k < ordenarElementos.size(); k++) {
                    vProceso.add(ordenarElementos.get(k));
                }
                Proceso.add(vProceso);
            }
            Proceso.add("");
        }
        long fin = System.nanoTime();
        long timpo = fin - inc;
        double seg = (double) (timpo) * 1.0e-9;

        lstProceso.setListData(Proceso);
        txtDatosOrdenados.setText("" + ordenarElementos);
        txttiempo1.setText(timpo + " ");
        txtssegundos.setText(seg + " ");
        txtPasadas.setText(ordenarElementos.size() - 1 + "");

    }//GEN-LAST:event_btnOrdenarActionPerformed

    private void btnNuevoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnNuevoActionPerformed
        txtPasadas.setText("");
        txtElemento.setText("");
        txtDatosVector.setText("");
        txtDatosOrdenados.setText("");
        txttiempo1.setText("");
        txtssegundos.setText(" ");
        Proceso = new Vector();
        lstProceso.setListData(Proceso);
        datos = new Vector();

    }//GEN-LAST:event_btnNuevoActionPerformed

    private void btnSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSalirActionPerformed
       Principal a = new Principal();
        a.setVisible(true);
        
      
        hide();
    }//GEN-LAST:event_btnSalirActionPerformed

    private void txtDatosVectorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtDatosVectorActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtDatosVectorActionPerformed

    private void txtssegundosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtssegundosActionPerformed

    }//GEN-LAST:event_txtssegundosActionPerformed

    private void txttiempo1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txttiempo1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txttiempo1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;

                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Ventana_Metodo_Burbuja.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Ventana_Metodo_Burbuja.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Ventana_Metodo_Burbuja.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Ventana_Metodo_Burbuja.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Ventana_Metodo_Burbuja().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAgregar;
    private javax.swing.JButton btnNuevo;
    private javax.swing.JButton btnOrdenar;
    private javax.swing.JButton btnSalir;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblDatosOrdenados;
    private javax.swing.JLabel lblDatosVector;
    private javax.swing.JLabel lblElemento;
    private javax.swing.JLabel lblProceso;
    private javax.swing.JLabel lblProceso1;
    private javax.swing.JLabel lblProceso2;
    private javax.swing.JLabel lblTitulo;
    private javax.swing.JList lstProceso;
    private javax.swing.JTextField txtDatosOrdenados;
    private javax.swing.JTextField txtDatosVector;
    private javax.swing.JTextField txtElemento;
    private javax.swing.JTextField txtPasadas;
    private javax.swing.JTextField txtssegundos;
    private javax.swing.JTextField txttiempo1;
    // End of variables declaration//GEN-END:variables
}
